From 030e81bbada80313471ab43f4081077707ec6d11 Mon Sep 17 00:00:00 2001
From: alwu <alwu@mozilla.com>
Date: Fri, 21 Feb 2025 06:50:14 +0000
Subject: [PATCH 09/15] BACKPORT: Bug 1894818 - part2 : add gfx feature for
 hevc. r=stransky

Differential Revision: https://phabricator.services.mozilla.com/D238154
---
 gfx/config/gfxFeature.h     |  1 +
 gfx/config/gfxVars.h        |  1 +
 gfx/thebes/gfxPlatform.cpp  | 11 ++++++++++-
 widget/GfxInfoFeatureDefs.h |  2 ++
 widget/gtk/GfxInfo.cpp      |  3 ++-
 5 files changed, 16 insertions(+), 2 deletions(-)

diff --git a/gfx/config/gfxFeature.h b/gfx/config/gfxFeature.h
index 71cb222278ab..28aa86c8f245 100644
--- a/gfx/config/gfxFeature.h
+++ b/gfx/config/gfxFeature.h
@@ -52,6 +52,7 @@ namespace gfx {
   _(ACCELERATED_CANVAS2D, Feature, "Accelerated Canvas2D")                   \
   _(H264_HW_DECODE, Feature, "H.264 hardware decoding")                      \
   _(AV1_HW_DECODE, Feature, "AV1 hardware decoding")                         \
+  _(HEVC_HW_DECODE, Feature, "HEVC hardware decoding")                       \
   _(REMOTE_CANVAS, Feature, "Remote canvas")                                 \
   _(DMABUF_WEBGL, Feature, "DMABuf for WebGL")                               \
   /* Add new entries above this comment */
diff --git a/gfx/config/gfxVars.h b/gfx/config/gfxVars.h
index 496efcb0d025..4307bf1d3095 100644
--- a/gfx/config/gfxVars.h
+++ b/gfx/config/gfxVars.h
@@ -93,6 +93,7 @@ class gfxVarReceiver;
   _(UseVP9HwDecode, bool, false)                                   \
   _(UseAV1HwDecode, bool, false)                                   \
   _(UseH264HwDecode, bool, false)                                  \
+  _(UseHEVCHwDecode, bool, false)                                  \
   _(HwDecodedVideoZeroCopy, bool, false)                           \
   _(UseDMABufSurfaceExport, bool, true)                            \
   _(ReuseDecoderDevice, bool, false)                               \
diff --git a/gfx/thebes/gfxPlatform.cpp b/gfx/thebes/gfxPlatform.cpp
index eb299a6bdbfe..b9bf7e9d8fe3 100644
--- a/gfx/thebes/gfxPlatform.cpp
+++ b/gfx/thebes/gfxPlatform.cpp
@@ -3008,7 +3008,7 @@ void gfxPlatform::InitHardwareVideoConfig() {
   }
   gfxVars::SetUseVP9HwDecode(featureVP9.IsEnabled());
 
-  // H264_HW_DECODE/AV1_HW_DECODE is used on Linux only right now.
+  // H264/AV1/HEVC_HW_DECODE are used on Linux only right now.
 #ifdef MOZ_WIDGET_GTK
   FeatureState& featureH264 = gfxConfig::GetFeature(Feature::H264_HW_DECODE);
   featureH264.EnableByDefault();
@@ -3027,6 +3027,15 @@ void gfxPlatform::InitHardwareVideoConfig() {
     featureAV1.Disable(FeatureStatus::Blocklisted, message.get(), failureId);
   }
   gfxVars::SetUseAV1HwDecode(featureAV1.IsEnabled());
+
+  FeatureState& featureHEVC = gfxConfig::GetFeature(Feature::HEVC_HW_DECODE);
+  featureHEVC.EnableByDefault();
+
+  if (!IsGfxInfoStatusOkay(nsIGfxInfo::FEATURE_HEVC_HW_DECODE, &message,
+                           failureId)) {
+    featureHEVC.Disable(FeatureStatus::Blocklisted, message.get(), failureId);
+  }
+  gfxVars::SetUseHEVCHwDecode(featureHEVC.IsEnabled());
 #endif
 }
 
diff --git a/widget/GfxInfoFeatureDefs.h b/widget/GfxInfoFeatureDefs.h
index f489dde5fed0..985a5d89aa9d 100644
--- a/widget/GfxInfoFeatureDefs.h
+++ b/widget/GfxInfoFeatureDefs.h
@@ -103,6 +103,8 @@ GFXINFO_FEATURE(ACCELERATED_CANVAS2D, "ACCELERATED_CANVAS2D", "accelerated-canva
 GFXINFO_FEATURE(H264_HW_DECODE, "H264_HW_DECODE", "h264.hw-decode")
 /* Whether hardware AV1 decoding is supported, starting in 114; downloadable blocking in 132. */
 GFXINFO_FEATURE(AV1_HW_DECODE, "AV1_HW_DECODE", "av1.hw-decode")
+/* Whether hardware HEVC decoding is supported, starting and downloadable blocking in 137. */
+GFXINFO_FEATURE(HEVC_HW_DECODE, "HEVC_HW_DECODE", "hevc.hw-decode")
 /* Whether video overlay of software decoded video is supported, starting in 116; downloadable blocking in 132. */
 GFXINFO_FEATURE(VIDEO_SOFTWARE_OVERLAY, "VIDEO_SOFTWARE_OVERLAY", "video-software-overlay")
 /* Whether WebGL is allowed to use hardware rendering, otherwise software fallbacks, starting in 120 (115esr); downloadable blocking in 132. */
diff --git a/widget/gtk/GfxInfo.cpp b/widget/gtk/GfxInfo.cpp
index 65b66dd10ce7..e7f4ca87f13e 100644
--- a/widget/gtk/GfxInfo.cpp
+++ b/widget/gtk/GfxInfo.cpp
@@ -1298,7 +1298,8 @@ nsresult GfxInfo::GetFeatureStatusImpl(
   } kFeatureToCodecs[] = {{nsIGfxInfo::FEATURE_H264_HW_DECODE, CODEC_HW_H264},
                           {nsIGfxInfo::FEATURE_VP8_HW_DECODE, CODEC_HW_VP8},
                           {nsIGfxInfo::FEATURE_VP9_HW_DECODE, CODEC_HW_VP9},
-                          {nsIGfxInfo::FEATURE_AV1_HW_DECODE, CODEC_HW_AV1}};
+                          {nsIGfxInfo::FEATURE_AV1_HW_DECODE, CODEC_HW_AV1},
+                          {nsIGfxInfo::FEATURE_HEVC_HW_DECODE, CODEC_HW_HEVC}};
 
   for (const auto& pair : kFeatureToCodecs) {
     if (aFeature != pair.mFeature) {
-- 
2.48.1

